#include <math.h>
#include <stdlib.h>

#include "qstring.h"

// returns the atomic mass for a given element
double AtomicMass( QString elem )
{
  if (elem=="MO")  return 95.94;
}


// Calculation of an index into stacklen. Item is numbered from zero.
// If item is greater or equal than stacklen (exceeds the number of items in the stack),
// the idx is calculated from the beginning of the stack. In other words, idx can
// never exceed stacklen-1.
int CalcIndex( int item, int stacklen )
{
  div_t dstruct;
  int idx;

  if (item<stacklen)
    return item;
  else {
    dstruct = div(item,stacklen);
    return dstruct.rem;
  }
}


// Returns the file name with extension .dd.
QString CreateFName( QString fname, QString ext )
{
  QString fnew;
  int pos;

  fnew = fname;

  // if saving from .plt file...
  pos = fnew.findRev(".plt");
  if (pos>=0)
    fnew.truncate(pos);

  // if saving .dd, don't append <ext> to make it .dd<ext>
  pos = fnew.findRev(".dd");
  if (pos>=0)
    fnew.truncate(pos);

  fnew.append(ext); 

  return fnew;
}


// Compares two numbers and returns true if they are the same 
// within the specified tolerance
bool isequal( double num1, double num2, double tol=1e-4 )
{
  return (num1<=num2+tol) && (num1>=num2-tol);
}
